#[derive(Debug)]
struct Rectangle {
    width: u32,
    height: u32,
}

// it is rare to see just "self" alone.
// Typically always see "&self"
// This is also very similar to Haskell
impl Rectangle {
    // urhmm actkually these are *methods* and not *functions*
    fn area(&self) -> u32 {
        self.width * self.height
    }

    fn width(&self) -> bool {
        self.width > 0
    }

    fn set_width(&mut self, width: u32) {
        self.width = width;
    }

    fn max(self, other: Rectangle) -> Rectangle {
        Rectangle {
            width: self.width.max(other.width),
            height: self.height.max(other.height),
        }
    }
}

fn main() {
    let rect1 = Rectangle {
        width: 30,
        height: 50,
    };

    println!(
        "The area of the rectangle is {} square pixels.",
        rect1.area()
    );

    if rect1.width() {
        println!("rect has a nonzero width; it is: {}", rect1.width);
    }

    // need mutable reference to set width
    let rect0 = Rectangle {
        width: 0,
        height: 0,
    };

    println!("{}", rect0.area());
    let other_rect = Rectangle {
        width: 1,
        height: 1,
    };
    let max_rect = rect0.max(other_rect); // can't use rect0 after passing to max

    let mut mut_rect = Rectangle {
        width: 0,
        height: 0,
    };
    mut_rect.set_width(9);
}
